# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2019-01-29.      #
#                                                           #
# Ruby Bindings Version 2.1.21                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Galvanically isolates any Bricklet from any Brick
  class BrickletIsolator < Device
    DEVICE_IDENTIFIER = 2122 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Isolator Bricklet' # :nodoc:

    FUNCTION_GET_STATISTICS = 1 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 2 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 3 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE = 4 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE = 5 # :nodoc:
    FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT = 6 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_STATISTICS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


    end

    # Returns statistics for the Isolator Bricklet.
    def get_statistics
      send_request FUNCTION_GET_STATISTICS, [], '', 18, 'L L S Z8'
    end

    # The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    # enabled, the Isolator Bricklet will try to adapt the baudrate for the communication
    # between Bricks and Bricklets according to the amount of data that is transferred.
    # 
    # The baudrate for communication config between
    # Brick and Isolator Bricklet can be set through the API of the Brick.
    # 
    # The baudrate will be increased exponentially if lots of data is send/received and
    # decreased linearly if little data is send/received.
    # 
    # This lowers the baudrate in applications where little data is transferred (e.g.
    # a weather station) and increases the robustness. If there is lots of data to transfer
    # (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    # 
    # In cases where some data has to transferred as fast as possible every few seconds
    # (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    # the dynamic baudrate off to get the highest possible performance.
    # 
    # The maximum value of the baudrate can be set per port with the function
    # BrickletIsolator#set_spitfp_baudrate. If the dynamic baudrate is disabled, the baudrate
    # as set by BrickletIsolator#set_spitfp_baudrate will be used statically.
    # 
    # The minimum dynamic baudrate has a value range of 400000 to 2000000 baud.
    # 
    # By default dynamic baudrate is enabled and the minimum dynamic baudrate is 400000.
    def set_spitfp_baudrate_config(enable_dynamic_baudrate, minimum_dynamic_baudrate)
      send_request FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, [enable_dynamic_baudrate, minimum_dynamic_baudrate], '? L', 0, ''
    end

    # Returns the baudrate config, see BrickletIsolator#set_spitfp_baudrate_config.
    def get_spitfp_baudrate_config
      send_request FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, [], '', 5, '? L'
    end

    # Sets the baudrate for a the communication between Isolator Bricklet
    # and the connected Bricklet. The baudrate for communication between
    # Brick and Isolator Bricklet can be set through the API of the Brick.
    # 
    # The baudrate can be in the range 400000 to 2000000.
    # 
    # If you want to increase the throughput of Bricklets you can increase
    # the baudrate. If you get a high error count because of high
    # interference (see BrickletIsolator#get_spitfp_error_count) you can decrease the
    # baudrate.
    # 
    # If the dynamic baudrate feature is enabled, the baudrate set by this
    # function corresponds to the maximum baudrate (see BrickletIsolator#set_spitfp_baudrate_config).
    # 
    # Regulatory testing is done with the default baudrate. If CE compatibility
    # or similar is necessary in you applications we recommend to not change
    # the baudrate.
    # 
    # The default baudrate for all ports is 1400000.
    def set_spitfp_baudrate(baudrate)
      send_request FUNCTION_SET_SPITFP_BAUDRATE, [baudrate], 'L', 0, ''
    end

    # Returns the baudrate, see BrickletIsolator#set_spitfp_baudrate.
    def get_spitfp_baudrate
      send_request FUNCTION_GET_SPITFP_BAUDRATE, [], '', 4, 'L'
    end

    # Returns the error count for the communication between Isolator Bricklet and
    # the connected Bricklet. Call BrickletIsolator#get_spitfp_error_count to get the
    # error count between Isolator Bricklet and Brick.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    def get_isolator_spitfp_error_count
      send_request FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT, [], '', 16, 'L L L L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 16, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 1, 'C'
    end

    # Returns the current bootloader mode, see BrickletIsolator#set_bootloader_mode.
    def get_bootloader_mode
      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 1, 'C'
    end

    # Sets the firmware pointer for BrickletIsolator#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 0, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIsolator#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 1, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 0, ''
    end

    # Returns the configuration as set by BrickletIsolator#set_status_led_config
    def get_status_led_config
      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 1, 'C'
    end

    # Returns the temperature in °C as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 2, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      send_request FUNCTION_RESET, [], '', 0, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      send_request FUNCTION_WRITE_UID, [uid], 'L', 0, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      send_request FUNCTION_READ_UID, [], '', 4, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

  end
end
